% Main script for CS 4758/6758 HW3 Q3
% 
% Trains human pose classifiers using a leave-person-out cross-validation
% approach and evaluates performance on the training and test sets for each
% split

%% Load data and set up globals for link indices
load poseData;

setupLinkInds;

%% Find the people indices in this dataset and count the number of people
nPeople = max(person);
nClasses = max(class);

%% Extract features from the pose data
poseFeat = relPFeatForAllBothArms(P,R);

%% Initialize output
splitTrainPrec = zeros(nPeople,nClasses);
splitTrainRec = zeros(nPeople,nClasses);

splitTestPrec = zeros(nPeople,nClasses);
splitTestRec = zeros(nPeople,nClasses);

splitTrainConf = zeros(nPeople,nClasses,nClasses);
splitTestConf = zeros(nPeople,nClasses,nClasses);

%% Make cross-validation sets by splitting based on person
%  Train and evaluate classifiers for each split
for i = 1:nPeople
    
    % Create trainData, trainClasses, testData, and testClasses by
    % separating out the data for the current person for testing, and using
    % the rest for training. The splitData function will probably be useful
    % here
    
    % YOUR CODE HERE
    
    % Whiten the data by dropping means and dividing by standard deviations
    % Use the parameters from the training data to whiten the test data
    [trainData,testData] = whitenData(trainData,testData);
    
    % Train a multinomial logistic classifier on the training data
    B = mnrfit(trainData,trainClasses);
    
    % Evaluate results on the training and test data, and record results
    % 
    % NOTE: You have to implement confToPrecRec, which is used by
    % evaluateMRNClass! Precision and recall will be all zeros until you
    % do this    
    [trainConf,trainPrec,trainRec] = evaluateMNRClass(B,trainData,trainClasses);
    [testConf,testPrec,testRec] = evaluateMNRClass(B,testData,testClasses);
    
    splitTrainPrec(i,:) = trainPrec;
    splitTrainRec(i,:) = trainRec;
    
    splitTestPrec(i,:) = testPrec;
    splitTestRec(i,:) = testRec;
    
    splitTrainConf(i,:,:) = trainConf;
    splitTestConf(i,:,:) = testConf;
end    